﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Profiling_Students
{
    public class StudentManager
    {
        List<Student> studentClass;

        public StudentManager()
        {
            studentClass = new List<Student>();
        }
        
        public void AddStudent(Student student)
        {
            studentClass.Add(student);
        }

        public void RemoveStudent(Student student)
        {
            studentClass.Remove(student);
        }

        public void GenerateRandomStudents(string[] firstName, string[] lastName)
        {
            Random rnd = new Random();
            studentClass.Clear();
            for (int i = 0; i < firstName.Length; i++)
                for (int j = 0; j < lastName.Length; j++)
                {
                    AddStudent(new Student(firstName[i], lastName[j], 1960 + rnd.Next(59)));
                }

           // Use this if randomization is required
           // studentClass = studentClass.OrderBy(student => rnd.Next()).ToList();
        }
                
        public Student GetStudentByName(string name)
        {
            if (studentClass.Count == 0) return null;

            Student studentResult = null;

            foreach (Student student in studentClass)
                if (student.Name == name)
                {
                    studentResult = student;
                    Console.WriteLine($"The student {name} has found: {studentResult}");
                }

            return studentResult;
        }

        private Student GetOldestStudentByAge()
        {
            if (studentClass.Count == 0) return null;

            int oldestYear = studentClass[0].Age;
            Student oldestStudent = studentClass[0];

            foreach (Student student in studentClass)
                if (oldestYear < student.Age)
                {
                    oldestYear = student.Age;
                    oldestStudent = student;
                    Debug.WriteLine($">> Debug: New oldest student candidate found! {oldestStudent} with age {oldestStudent.Age}");
                }

            return oldestStudent;
        }

        public void ListStudentsByAge()
        {
            List<Student> newList = new List<Student>();
            Student oldestStudent = null;
            do
            {
                oldestStudent = GetOldestStudentByAge();
                if (oldestStudent != null)
                {
                    Console.WriteLine($"Oldest student is now {oldestStudent}");
                    RemoveStudent(oldestStudent);
                    newList.Add(oldestStudent);
                }
            }
            while (oldestStudent != null);
            studentClass = newList;
        }
    }

}
